Package org.mozilla.javascript

## Class NativeJavaMap

- java.lang.Object
- - org.mozilla.javascript.NativeJavaObject
  - - org.mozilla.javascript.NativeJavaMap

- All Implemented Interfaces:
    `java.io.Serializable`, `Scriptable`, `SymbolScriptable`, `Wrapper`

      public class NativeJavaMap
      extends NativeJavaObject

  `NativeJavaMap` is a wrapper for java objects implementing `java.util.Map` interface. When `Context.FEATURE_ENABLE_JAVA_MAP_ACCESS` is enabled, property based access like `map[key]` is delegated to `Map.get(Object)` or `Map.put(Object, Object)` operations so that a `JavaMap` acts very similar to a javascript `Object` There is also an iterator to iterate over entries with `for .. of`.

  Limitations: The wrapped map should have `String` or `Integer` as key. Otherwise, property based access may not work properly.

  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.mozilla.javascript.NativeJavaObject

      `isAdapter, javaObject, members, parent, prototype, staticType`

    - ### Fields inherited from interface org.mozilla.javascript.Scriptable

      `NOT_FOUND`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NativeJavaMap​(Scriptable scope, java.lang.Object map)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(java.lang.Object obj)` |
    `java.lang.Object` | `get​(int index, Scriptable start)` | Get a property from the object selected by an integral index.
    `java.lang.Object` | `get​(java.lang.String name, Scriptable start)` | Get a named property from the object.
    `java.lang.Object` | `get​(Symbol key, Scriptable start)` | Return the value of the property with the specified key, or NOT_FOUND.
    `java.lang.String` | `getClassName()` | Get the name of the set of objects implemented by this Java class.
    `java.lang.Object[]` | `getIds()` | Get an array of property ids.
    `boolean` | `has​(int index, Scriptable start)` | Indicates whether or not an indexed property is defined in an object.
    `boolean` | `has​(java.lang.String name, Scriptable start)` | Indicates whether or not a named property is defined in an object.
    `boolean` | `has​(Symbol key, Scriptable start)` | Return true if the specified property exists.
    `int` | `hashCode()` |
    `void` | `put​(int index, Scriptable start, java.lang.Object value)` | Sets an indexed property in this object.
    `void` | `put​(java.lang.String name, Scriptable start, java.lang.Object value)` | Sets a named property in this object.

    - ### Methods inherited from class org.mozilla.javascript.NativeJavaObject

      `canConvert, coerceType, createInterfaceAdapter, delete, delete, delete, getDefaultValue, getParentScope, getPrototype, hasInstance, initMembers, put, setParentScope, setPrototype, unwrap, wrap`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### NativeJavaMap

          public NativeJavaMap​(Scriptable scope,
                               java.lang.Object map)

  - ### Method Detail

    - #### getClassName

          public java.lang.String getClassName()

      Description copied from interface: `Scriptable`
      Get the name of the set of objects implemented by this Java class. This corresponds to the [[Class]] operation in ECMA and is used by Object.prototype.toString() in ECMA.

      See ECMA 8.6.2 and 15.2.4.2.

      Specified by:
        `getClassName` in interface `Scriptable`
      Overrides:
        `getClassName` in class `NativeJavaObject`

    - #### has

          public boolean has​(java.lang.String name,
                             Scriptable start)

      Description copied from interface: `Scriptable`
      Indicates whether or not a named property is defined in an object.

      Does not traverse the prototype chain.

      The property is specified by a String name as defined for the `get` method.

      Specified by:
        `has` in interface `Scriptable`
      Overrides:
        `has` in class `NativeJavaObject`
      Parameters:
        `name` - the name of the property
        `start` - the object in which the lookup began
      Returns:
        true if and only if the named property is found in the object
      See Also:
        `Scriptable.get(String, Scriptable)`, `ScriptableObject.getProperty(Scriptable, String)`

    - #### has

          public boolean has​(int index,
                             Scriptable start)

      Description copied from interface: `Scriptable`
      Indicates whether or not an indexed property is defined in an object.

      Does not traverse the prototype chain.

      The property is specified by an integral index as defined for the `get` method.

      Specified by:
        `has` in interface `Scriptable`
      Overrides:
        `has` in class `NativeJavaObject`
      Parameters:
        `index` - the numeric index for the property
        `start` - the object in which the lookup began
      Returns:
        true if and only if the indexed property is found in the object
      See Also:
        `Scriptable.get(int, Scriptable)`, `ScriptableObject.getProperty(Scriptable, int)`

    - #### has

          public boolean has​(Symbol key,
                             Scriptable start)

      Description copied from interface: `SymbolScriptable`
      Return true if the specified property exists.
      Specified by:
        `has` in interface `SymbolScriptable`
      Overrides:
        `has` in class `NativeJavaObject`

    - #### get

          public java.lang.Object get​(java.lang.String name,
                                      Scriptable start)

      Description copied from interface: `Scriptable`
      Get a named property from the object.

      Looks property up in this object and returns the associated value if found. Returns NOT_FOUND if not found. Note that this method is not expected to traverse the prototype chain. This is different from the ECMA [[Get]] operation.

      Depending on the property selector, the runtime will call this method or the form of `get` that takes an integer:

      JavaScript code | Java code
      --- | ---
      a.b | a.get("b", a)
      a["foo"] | a.get("foo", a)
      a[3] | a.get(3, a)
      a["3"] | a.get(3, a)
      a[3.0] | a.get(3, a)
      a["3.0"] | a.get("3.0", a)
      a[1.1] | a.get("1.1", a)
      a[-4] | a.get(-4, a)

      The values that may be returned are limited to the following:

      - java.lang.Boolean objects
      - java.lang.String objects
      - java.lang.Number objects
      - org.mozilla.javascript.Scriptable objects
      - null
      - The value returned by Context.getUndefinedValue()
      - NOT_FOUND
      Specified by:
        `get` in interface `Scriptable`
      Overrides:
        `get` in class `NativeJavaObject`
      Parameters:
        `name` - the name of the property
        `start` - the object in which the lookup began
      Returns:
        the value of the property (may be null), or NOT_FOUND
      See Also:
        `Context.getUndefinedValue()`

    - #### get

          public java.lang.Object get​(int index,
                                      Scriptable start)

      Description copied from interface: `Scriptable`
      Get a property from the object selected by an integral index.

      Identical to `get(String, Scriptable)` except that an integral index is used to select the property.

      Specified by:
        `get` in interface `Scriptable`
      Overrides:
        `get` in class `NativeJavaObject`
      Parameters:
        `index` - the numeric index for the property
        `start` - the object in which the lookup began
      Returns:
        the value of the property (may be null), or NOT_FOUND
      See Also:
        `Scriptable.get(String,Scriptable)`

    - #### get

          public java.lang.Object get​(Symbol key,
                                      Scriptable start)

      Description copied from interface: `SymbolScriptable`
      Return the value of the property with the specified key, or NOT_FOUND.
      Specified by:
        `get` in interface `SymbolScriptable`
      Overrides:
        `get` in class `NativeJavaObject`

    - #### put

          public void put​(java.lang.String name,
                          Scriptable start,
                          java.lang.Object value)

      Description copied from interface: `Scriptable`
      Sets a named property in this object.

      The property is specified by a string name as defined for `get`.

      The possible values that may be passed in are as defined for `get`. A class that implements this method may choose to ignore calls to set certain properties, in which case those properties are effectively read-only.

      For properties defined in a prototype chain, use `putProperty` in ScriptableObject.

      Note that if a property a is defined in the prototype p of an object o, then evaluating `o.a = 23` will cause `set` to be called on the prototype p with o as the start parameter. To preserve JavaScript semantics, it is the Scriptable object's responsibility to modify o.

      This design allows properties to be defined in prototypes and implemented in terms of getters and setters of Java values without consuming slots in each instance.

      The values that may be set are limited to the following:

      - java.lang.Boolean objects
      - java.lang.String objects
      - java.lang.Number objects
      - org.mozilla.javascript.Scriptable objects
      - null
      - The value returned by Context.getUndefinedValue()

      Arbitrary Java objects may be wrapped in a Scriptable by first calling `Context.toObject`. This allows the property of a JavaScript object to contain an arbitrary Java object as a value.

      Note that `has` will be called by the runtime first before `set` is called to determine in which object the property is defined. Note that this method is not expected to traverse the prototype chain, which is different from the ECMA [[Put]] operation.

      Specified by:
        `put` in interface `Scriptable`
      Overrides:
        `put` in class `NativeJavaObject`
      Parameters:
        `name` - the name of the property
        `start` - the object whose property is being set
        `value` - value to set the property to
      See Also:
        `Scriptable.has(String, Scriptable)`, `Scriptable.get(String, Scriptable)`, `ScriptableObject.putProperty(Scriptable, String, Object)`, `Context.toObject(Object, Scriptable)`

    - #### put

          public void put​(int index,
                          Scriptable start,
                          java.lang.Object value)

      Description copied from interface: `Scriptable`
      Sets an indexed property in this object.

      The property is specified by an integral index as defined for `get`.

      Identical to `put(String, Scriptable, Object)` except that an integral index is used to select the property.

      Specified by:
        `put` in interface `Scriptable`
      Overrides:
        `put` in class `NativeJavaObject`
      Parameters:
        `index` - the numeric index for the property
        `start` - the object whose property is being set
        `value` - value to set the property to
      See Also:
        `Scriptable.has(int, Scriptable)`, `Scriptable.get(int, Scriptable)`, `ScriptableObject.putProperty(Scriptable, int, Object)`, `Context.toObject(Object, Scriptable)`

    - #### getIds

          public java.lang.Object[] getIds()

      Description copied from interface: `Scriptable`
      Get an array of property ids.

      Not all property ids need be returned. Those properties whose ids are not returned are considered non-enumerable.

      Specified by:
        `getIds` in interface `Scriptable`
      Overrides:
        `getIds` in class `NativeJavaObject`
      Returns:
        an array of Objects. Each entry in the array is either a java.lang.String or a java.lang.Number

    - #### equals

          public boolean equals​(java.lang.Object obj)

      Overrides:
        `equals` in class `NativeJavaObject`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `NativeJavaObject`